/*
 * @(#)JavaCGIBridgeStillProcessingException.java 1.00 08/10/97
 *
 * Copyright Info: This class was written by Gunther Birznieks
 * (birzniek@hlsun.redcross.org) and Selena Sol (selena@eff.org) 
 * having been inspired by countlessd other Perl authors.
 * 
 * Feel free to copy, cite, reference, sample, borrow, resell
 * or plagiarize the contents.  However, if you don't mind,
 * please let Selena know where it goes so that we can at least
 * watch and take part in the development of the memes. Information
 * wants to be free; support public domain freeware.  Donations are
 * appreciated and will be spent on further upgrades and other public
 * domain programs.
 *
 */

package com.extropia.net;

/**
 * Signals that the user is trying to use this class when it is 
 * still processing some request.  Even though an operation may
 * not involve return feedback such as a oneway operation, it
 * still involves processing time behind the scenes.
 *
 * @version     1.00, 10 Aug 1997
 */

public
class JavaCGIBridgeStillProcessingException extends RuntimeException {
    /**
     * Constructs a JavaCGIBridgeStillProcessingException with no detail message.
     * A detail message is a String that describes this particular
     * exception.
     */
     public JavaCGIBridgeStillProcessingException() {
         super();
     }

    /**
     * Constructs a JavaCGIBridgeStillProcessingException with the specified
     * detail message. A detail message is a String that describes
     * this particular exception.
     * @param s the String that contains a detailed message
     */

     public JavaCGIBridgeStillProcessingException(String s) {
         super(s);
     }
}

